//
//  NSArray-ZEditExtension.m
//  ZEdit
//
//  Created by 増田 勇樹 on 07/03/05.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "NSArray-ZEditExtension.h"


@implementation NSArray (ZEditExtension)
- (NSArray *)objectsAcceptedBySelector:(SEL)selector
{
	NSMutableArray *result = [NSMutableArray array];
	NSEnumerator *objects = [self objectEnumerator];
	id o;
	while((o = [objects nextObject]) != nil)
	{
		BOOL (*method)(id, SEL);
		method = (BOOL (*)(id, SEL))[o methodForSelector:selector];
		if(method != nil)
		{
			if(method(o, selector))
			{
				[result addObject:o];
			}
		}
	}
	return [[result copy] autorelease];
}

- (NSArray *)objectsAcceptedBySelector:(SEL)selector argument:(id)argument
{
	NSMutableArray *result = [NSMutableArray array];
	NSEnumerator *objects = [self objectEnumerator];
	id o;
	while((o = [objects nextObject]) != nil)
	{
		BOOL (*method)(id, SEL, id);
		method = (BOOL (*)(id, SEL, id))[o methodForSelector:selector];
		if(method != nil)
		{
			if(method(o, selector, argument))
			{
				[result addObject:o];
			}
		}
	}
	return [[result copy] autorelease];
}

- (BOOL)logicalAndUnsingSelector:(SEL)selector
{
	NSEnumerator *objects = [self objectEnumerator];
	id o;
	while((o = [objects nextObject]) != nil)
	{
		BOOL (*method)(id, SEL);
		method = (BOOL (*)(id, SEL))[o methodForSelector:selector];
		if(method != nil)
		{
			if(!method(o, selector))
			{
				return NO;
			}
		}
	}
	return YES;
}

- (BOOL)logicalAndUnsingSelector:(SEL)selector argument:(id)argument
{
	NSEnumerator *objects = [self objectEnumerator];
	id o;
	while((o = [objects nextObject]) != nil)
	{
		BOOL (*method)(id, SEL, id);
		method = (BOOL (*)(id, SEL, id))[o methodForSelector:selector];
		if(method != nil)
		{
			if(!method(o, selector, argument))
			{
				return NO;
			}
		}
	}
	return YES;
}

- (BOOL)logicalOrUsingSelector:(SEL)selector
{
	NSEnumerator *objects = [self objectEnumerator];
	id o;
	while((o = [objects nextObject]) != nil)
	{
		BOOL (*method)(id, SEL);
		method = (BOOL (*)(id, SEL))[o methodForSelector:selector];
		if(method != nil)
		{
			if(method(o, selector))
			{
				return YES;
			}
		}
	}
	return NO;
}

- (BOOL)logicalOrUnsingSelector:(SEL)selector argument:(id)argument
{
	NSEnumerator *objects = [self objectEnumerator];
	id o;
	while((o = [objects nextObject]) != nil)
	{
		BOOL (*method)(id, SEL, id);
		method = (BOOL (*)(id, SEL, id))[o methodForSelector:selector];
		if(method != nil)
		{
			if(method(o, selector, argument))
			{
				return YES;
			}
		}
	}
	return NO;
}
@end
