//
//  NSData-ZEditExtention.m
//  ZEdit
//
//  Created by 増田 勇樹 on 08/10/24.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "NSData-ZEditExtention.h"

#include "guess.h"

#define SHIFT_JIS 0x80000001

@implementation NSData (ZEditExtention)
- (NSStringEncoding)stringEncoding
{
	const char *bytes = (const char *)[self bytes];
	const char *result = guess_jp(bytes, [self length], nil);
	if(result == nil)
	{
		return 0;
	}
	if(strcmp(result, "ISO-2022-JP") == 0)
	{
		return NSISO2022JPStringEncoding;
	}
	else if(strcmp(result, "EUC-JP") == 0)
	{
		return NSJapaneseEUCStringEncoding;
	}
	else if(strcmp(result, "Shift_JIS") == 0)
	{
		return SHIFT_JIS;
	}
	else if(strcmp(result, "UTF-8") == 0)
	{
		return NSUTF8StringEncoding;
	}
	else
	{
		return 0;
	}
}
@end
