//
//  NSString-ZEditExtension.h
//  ZEdit
//
//  Created by 増田 勇樹 on 05/04/13.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

typedef enum
{
	NSStringLineBreakLF = 0,
	NSStringLineBreakCR = 1,
	NSStringLineBreakCRLF = 2,
	NSStringLineBreakUnicodeLineSeparator = 3,
	NSStringLineBreakUnicodeParagraphSeparator = 4,
} NSStringLineBreakStyle;


@interface NSString (ZEditExtension)
+ (NSStringEncoding)stringEncodingForLocalizedName:(NSString *)name;

+ (NSArray *)lineBreakStyleNames;

+ (NSString *)nameOfLineBreakStyle:(NSStringLineBreakStyle)style;
+ (NSStringLineBreakStyle)lineBreakStyleOfName:(NSString *)name;
- (NSStringLineBreakStyle)lineBreakStyle;
- (unsigned int)numberOfLines;
- (unsigned int)lineNumberAtIndex:(unsigned int)index;
- (unsigned int)getLineNumber:(unsigned int *)line atIndex:(unsigned int)index;
@end

@interface NSMutableString (ZEditExtension)
- (void)setLineBreakStyle:(NSStringLineBreakStyle)style;
@end
