//
//  ZArrayTransformer.m
//  ZEdit
//
//  Created by 増田 勇樹 on 08/10/25.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "ZArrayTransformer.h"


@implementation ZArrayTransformer
+ (Class)transformedValueClass
{
	return [NSArray class];
}

+ (BOOL)allowsReverseTransformation
{
	return YES; 
}

+ (ZArrayTransformer *)transFormerWithTransformer:(NSValueTransformer *)transformer
{
	return [[[ZArrayTransformer alloc] initWithTransformer:transformer] autorelease];
}

- (id)initWithTransformer:(NSValueTransformer *)transformer
{
	self = [super init];
	if(self != nil)
	{
		_transformer = [transformer retain];
	}
	return self;
}

-(void)dealloc
{
	[_transformer release];
	[super dealloc];
}

- (id)transformedValue:(id)value
{
	if(value == nil || ![value isKindOfClass:[NSArray class]])
	{
		return nil;
	}
	
	NSMutableArray *new = [NSMutableArray array];
	
	for(id v in value)
	{
		[new addObject:[_transformer transformedValue:v]];
	}
	return [[new copy] autorelease];
}

- (id)reverseTransformedValue:(id)value
{
	if(value == nil || ![value isKindOfClass:[NSArray class]])
	{
		return nil;
	}
	
	NSMutableArray *new = [NSMutableArray array];
	
	for(id v in value)
	{
		[new addObject:[_transformer reverseTransformedValue:v]];
	}
	return [[new copy] autorelease];
}
@end
