//
//  ZColoringParser.h
//  ZEdit
//
//  Created by 増田 勇樹 on 08/10/09.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import "ZStateParser.h"

/**********************************
* Keys for State Dictionary
***********************************/
extern NSString *StateParserBeginKey;		//@"begin". regex.
extern NSString *StateParserEndKey;			//@"end". regex.
extern NSString *StateParserTokenKey;		//@"token". regex.
extern NSString *StateParserSubstatesKey;	//@"substates". array of substate dictionaries.
extern NSString *StateParserParenthesesKey;	//@"parentheses". array of parenthesis dictionaries.
extern NSString *StateParserKeywordsKey;	//@"keywords". array of keyword dictionaries.
extern NSString *StateParserColorKey;		//@"color". color name defined in ZSyntax.h or string in format @"#rrggbb".
extern NSString *StateParserBackgroundKey;	//@"background". color name defined in ZSyntax.h or string in format @"#rrggbb".

/**********************************
* Keys for Keyword Dictionary
***********************************/
extern NSString *KeywordRegexsKey;	//@"regexes" array of regexes
// also use StateParserColorKey and StateParserBackgroundKey to specify colors of the keyword.

/**********************************
* Keys for Parenthesis Dictionary
***********************************/
extern NSString *ParenthesisBeginKey;			//@"begin". regex
extern NSString *ParenthesisEndKey;			//@"end". regex
// also use StateParserColorKey and StateParserBackgroundKey to specify colors of the parenthesis.

@interface ZColoringParser : ZStateParser
{

}

+ (ZColoringParser *)parserWithDescription:(NSDictionary *)description topLevel:(BOOL)topLevel;
@end
