//
//  ZDictionaryValueTransformer.m
//  ZEdit
//
//  Created by 増田 勇樹 on 08/10/10.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "ZDictionaryValueTransformer.h"

#import "ZArrayTransformer.h"

@implementation ZDictionaryValueTransformer
+ (Class)transformedValueClass
{
	return [NSDictionary class];
}

+ (BOOL)allowsReverseTransformation
{
	return YES; 
}

+ (ZDictionaryValueTransformer *)transFormerWithTransformer:(NSValueTransformer *)transformer
{
	return [[[ZDictionaryValueTransformer alloc] initWithTransformer:transformer] autorelease];
}

- (id)initWithTransformer:(NSValueTransformer *)transformer
{
	self = [super init];
	if(self != nil)
	{
		_arrayTransformer = [[ZArrayTransformer transFormerWithTransformer:transformer] retain];
	}
	return self;
}

-(void)dealloc
{
	[_arrayTransformer release];
	[super dealloc];
}

- (id)transformedValue:(id)value
{
	if(value == nil || ![value isKindOfClass:[NSDictionary class]])
	{
		return nil;
	}
	
	NSArray *newValues = [_arrayTransformer transformedValue:[value allValues]];
	return [NSDictionary dictionaryWithObjects:newValues forKeys:[value allKeys]];
}

- (id)reverseTransformedValue:(id)value
{
	if(value == nil || ![value isKindOfClass:[NSDictionary class]])
	{
		return nil;
	}
	
	NSArray *newValues = [_arrayTransformer reverseTransformedValue:[value allValues]];
	return [NSDictionary dictionaryWithObjects:newValues forKeys:[value allKeys]];
}
@end
