//
//  ZEditDirectoryDocument.m
//  ZEdit
//
//  Created by 増田 勇樹 on 07/03/15.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "ZEditDirectoryDocument.h"
#import "ZEditFileSystemItem.h"
#import "ZEditWindowController.h"

@implementation ZEditDirectoryDocument
- (id)initWithContentsOfURL:(NSURL *)url
	  ofType:(NSString *)typeName
	  error:(NSError **)outError
{
	self = [super init];
	if(self != nil)
	{
		[self setFileURL:url];
		[self setFileType:typeName];
	}
	return self;
}

- (id)initWithContentsOfURL:(NSURL *)url
	  ofType:(NSString *)typeName
	  sharedWindowController:(ZEditWindowController *)windowController
	  error:(NSError **)outError
{
	self = [self initWithContentsOfURL:url ofType:typeName error:outError];
	if(self != nil)
	{
		if(windowController != nil)
		{
			[self addWindowController:windowController];
		}
	}
	return self;
}

- (void)makeWindowControllers
{
	if([[self windowControllers] count] == 0)
	{
		ZEditFileSystemItem *rootDirectory = [ZEditFileSystemItem rootItemWithPath:[[self fileURL] path]];
		[rootDirectory setDocument:self];
		ZEditWindowController *windowController = [[[ZEditWindowController alloc] initWithWindowNibName:@"ZEditDocument"] autorelease];
		[windowController setRootDirectory:rootDirectory];
		[self addWindowController:windowController];
	}
}


- (BOOL)validateUserInterfaceItem:(id <NSValidatedUserInterfaceItem>)anItem
{
	return NO;
}
@end
