//
//  ZEditDocument.m
//  ZEdit
//
//  Created by 増田 勇樹 on 07/02/21.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "ZEditDocument.h"

#import "ZModeTextView.h"
#import "NSString-ZEditExtension.h"
#import "ZEditFileSystemItem.h"
#import "ZSyntax.h"
#import "ZEditWindowController.h"

@implementation ZEditDocument
- (id)initWithContentsOfURL:(NSURL *)url
	  ofType:(NSString *)typeName
	  sharedWindowController:(ZEditWindowController *)windowController
	  error:(NSError **)outError
{
	self = [super initWithContentsOfURL:url ofType:typeName error:outError];
	if(self != nil)
	{
		if(windowController != nil)
		{
			[self addWindowController:windowController];
		}
	}
	return self;
}

- (NSString *)autosavingFileType
{
	return nil;
}

- (void)makeWindowControllers
{
	if([[self windowControllers] count] == 0)
	{
		ZEditWindowController *windowController = [[[ZEditWindowController alloc] initWithWindowNibName:@"ZEditDocument"] autorelease];
		[self addWindowController:windowController];
	}
}

- (NSWindow *)window
{
	return [[self windowController] window];
}

- (ZEditWindowController *)windowController
{
	NSArray *controllers = [self windowControllers];
	if([controllers count] > 0)
	{
		return [controllers objectAtIndex:0];
	}
	else
	{
		return nil;
	}
}

- (NSView *)view
{
	return nil;
}

- (void)canCloseDocumentWithDelegate:(id)delegate shouldCloseSelector:(SEL)shouldCloseSelector contextInfo:(void *)contextInfo
{
	if([self windowController] != nil && delegate != [self windowController])
	{
		[[self windowController] canCloseAllDocumentWithDelegate:delegate didCloseAllSelector:shouldCloseSelector contextInfo:contextInfo sender:self];
	}
	else
	{
		[super canCloseDocumentWithDelegate:delegate shouldCloseSelector:shouldCloseSelector contextInfo:contextInfo];
	}
}
@end