//
//  ZEditTextDocument.h
//  ZEdit
//
//  Created by Youki Masuda on 8.4.2004.
//  Copyright (c) 2004 Youki Masuda. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import "ZEditDocument.h"
#import "NSString-ZEditExtension.h"

@class ZSyntax, ZModeTextView, ZFileSystemItem, ZEditDirectoryDocument;

@interface ZEditTextDocument : ZEditDocument
{
	ZModeTextView *_textView;
		
	NSStringLineBreakStyle _lineBreakStyle;
	NSStringEncoding _encoding;
}
- (void)setLineBreakStyle:(NSStringLineBreakStyle)style;
- (NSStringLineBreakStyle)lineBreakStyle;
- (IBAction)changeLineBreakStyle:(id)sender;

- (void)setEncoding:(NSStringEncoding)encoding;
- (NSStringEncoding)encoding;
- (IBAction)changeEncoding:(id)sender;
- (void)convertToEncoding:(NSStringEncoding)encoding;

- (ZModeTextView *)view;
- (NSTextStorage *)textStorage;

- (BOOL)readFromData:(NSData *)data ofType:(NSString *)typeName error:(NSError **)outError;
- (BOOL)readFromData:(NSData *)data withEncodings:(NSArray *)encodings error:(NSError **)outError;

- (NSData *)dataOfType:(NSString *)typeName error:(NSError **)outError;

- (BOOL)validateUserInterfaceItem:(id <NSValidatedUserInterfaceItem>)anItem;
@end
