//
//  ZFontUnarchiver.m
//  sEdit
//
//  Created by c E on Thu Aug 05 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "ZFontUnarchiver.h"

@implementation ZFontUnarchiver
+ (Class)transformedValueClass
{
    return [NSFont class];
}

+ (BOOL)allowsReverseTransformation
{
    return YES;
}

- (id)transformedValue:(id)value
{
	NSString *fontName = [value objectAtIndex:0];
	float fontSize = [[value objectAtIndex:1] floatValue];
	return [NSFont fontWithName:fontName size:fontSize];
}

- (id)reverseTransformedValue:(id)value
{
	return [NSArray arrayWithObjects:[value fontName], [NSNumber numberWithFloat:[value pointSize]], nil];
}
@end

@implementation FontNameUnarchiver
+ (Class)transformedValueClass
{
    return [NSString class];
}

+ (BOOL)allowsReverseTransformation
{
    return NO;
}

- (id)transformedValue:(id)aValue
{
	float fontSize = [[aValue objectAtIndex:1] floatValue];
	NSString *fontName = [[NSFont fontWithName:[aValue objectAtIndex:0] size:fontSize] displayName];
	return [NSString stringWithFormat:@"%@ - %@pt", fontName, [[NSNumber numberWithFloat:fontSize] stringValue]];
}
@end
