//
//  ZLineBreakMenuController.m
//  ZEdit
//
//  Created by 増田 勇樹 on 08/10/24.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "ZLineBreakMenuController.h"

#import "NSString-ZEditExtension.h"

#define LINEBREAK_KEY @"defaultLineBreakStyle"

@implementation ZLineBreakMenuController
+ (void)initialize
{
	NSUserDefaultsController *udc = [NSUserDefaultsController sharedUserDefaultsController];
	NSMutableDictionary *initialValues = [[[udc initialValues] mutableCopy] autorelease];
	if(initialValues == nil)
	{
		initialValues = [NSMutableDictionary dictionary];
	}
	NSString *lineBreak = [NSString nameOfLineBreakStyle:NSStringLineBreakLF];
	[initialValues setObject:lineBreak forKey:LINEBREAK_KEY];
	[udc setInitialValues:initialValues];
}

- (NSArray *)lineBreakStyleNames
{
	return [NSString lineBreakStyleNames];
}

- (void)menuNeedsUpdate:(NSMenu *)menu
{
	if([menu numberOfItems] == 0)
	{
		for(NSString *name in [self lineBreakStyleNames])
		{
			NSStringLineBreakStyle style = [NSString lineBreakStyleOfName:name];
		
			NSMenuItem *item = [[[NSMenuItem alloc] initWithTitle:name action:@selector(changeLineBreakStyle:) keyEquivalent:@""] autorelease];
			[item setTag:style];
			[menu addItem:item];
		}
	}
}
@end
