//
//  ZMode.h
//  ZEdit
//
//  Created by 増田 勇樹 on 08/11/02.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class ZSyntax;

extern NSString *ZModeResourceDirectory; //@"Modes"
extern NSString *ZModeFileExtension; //@"zmode"
extern NSString *ZModeDescriptionFileName; //@"mode.plist"
extern NSString *ZModeDefaultModeName; //@"Plain Text"

/****************************************
* Keys for dictionary in mode.plist File
*****************************************/
extern NSString *ZModeModeNameKey;	//@"syntaxName" : string.
extern NSString *ZModeExtendsKey;		//@"extends" : string
extern NSString *ZModeFileNameMatchKey;//@"fileNameMatch" : regular expression
extern NSString *ZModeAutoIndentKey;	//@"autoIndent" : BOOL
extern NSString *ZModeTabWidthKey;		//@"tabWidth" : integer

@interface ZMode : NSObject
{
	NSString *_name;
	NSString *_fileNameMatch;
	BOOL _autoIndent;
	unsigned _tabWidth;
	ZSyntax *_syntax;
}

+ (NSArray *)modes;
+ (ZMode *)modeWithName:(NSString *)name;
+ (ZMode *)modeForFile:(NSString *)fileName;

- (id)initWithDescription:(NSDictionary *)description;

@property(retain, readonly) NSString *name;
@property(retain, readonly) NSString *fileNameMatch;
@property(assign, readonly) BOOL autoIndent;
@property(assign, readonly) unsigned tabWidth;
@property(retain, readonly) ZSyntax *syntax;

- (NSParagraphStyle *)paragraphStyleForFont:(NSFont *)font;
- (void)applyIndentInTextStorage:(NSTextStorage *)storage location:(unsigned int)location;
@end
