//
//  ZParseTree.h
//  ZEdit
//
//  Created by 増田 勇樹 on 08/10/09.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class ZParser, ZParseTree;
@protocol ZParseTreeAction;

@interface ZParseTree : NSObject
{
	ZParser *_parser;
	NSRange _range;
	NSInteger _triggerLength;	
	NSMutableArray *_subtrees;
}

@property(retain, readonly) ZParser *parser;
@property(assign) NSRange range;
@property(assign) NSInteger triggerLength;
@property(assign, readonly) NSRange triggerRange;
@property(retain, readonly) NSMutableArray *subtrees;

+ (ZParseTree *)treeWithParser:(ZParser *)parser;

- (id)initWithParser:(ZParser *)parser;

- (NSMutableArray *)subtreesCreateIfNeeded:(BOOL)create;

- (void)shiftBy:(NSInteger)shift;

- (void)runActionInRange:(NSRange)range context:(void *)context;
@end