//
//  ZStringEdit.m
//  ZEdit
//
//  Created by 増田 勇樹 on 08/10/19.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "ZStringEdit.h"

@implementation ZStringEdit
@synthesize editedRange = _editedRange,
			changeInLength = _changeInLength;

+ (ZStringEdit *)editInRange:(NSRange)range
				changeInLength:(NSInteger)changeInLength
{
	return [[[ZStringEdit alloc] initWithEditedRange:range
								changeInLength:changeInLength] autorelease];
}

- (id)initWithEditedRange:(NSRange)range
	  changeInLength:(NSInteger)changeInLength
{
	self = [super init];
	if(self != nil)
	{
		_editedRange = range;
		_changeInLength = changeInLength;
	}
	return self;
}

- (void)dealloc
{
	[super dealloc];
}

- (NSRange)translatedRange:(NSRange)range
{
	int start = range.location;
	int end = NSMaxRange(range);
	
	if(start >= NSMaxRange(_editedRange))
	{
		start += _changeInLength;
	}
	else if(start >= _editedRange.location)
	{
		start = NSMaxRange(_editedRange) + _changeInLength;
	}
	
	if(end >= NSMaxRange(_editedRange))
	{
		end += _changeInLength;
	}
	else if(end >= _editedRange.location)
	{
		end = _editedRange.location;
	}
	if(end <= start)
	{
		return NSMakeRange(0, 0);
	}
	else
	{
		return NSMakeRange(start, end-start);
	}
}
@end
