//
//  ZSyntax-Private.m
//  ZEdit
//
//  Created by 増田 勇樹 on 08/10/11.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "ZSyntax-Private.h"

#import "ZParseTree.h"

@implementation ZSyntax (Private)
- (void)highlightRange:(NSRange)range
		inStorage:(NSTextStorage *)storage
		selectedTextAttributes:(NSDictionary *)selected
{
	NSDictionary *oldAttributes = [storage attributesAtIndex:range.location effectiveRange:nil];
	[[oldAttributes retain] autorelease];
	[storage beginEditing];
	[storage addAttributes:selected range:range];
	[storage endEditing];
	
	NSDictionary *info = [NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:range.location], @"rangeLocation",
																	[NSNumber numberWithInt:range.length], @"rangeLength",
																	oldAttributes, @"oldAttributes",
																	storage, @"storage",
																	nil];
	[NSTimer scheduledTimerWithTimeInterval:0.1 target:self selector:@selector(clearHighlight:) userInfo:info repeats:NO];
}

- (void)clearHighlight:(NSTimer *)timer
{
	NSDictionary *info = [timer userInfo];
	NSTextStorage *storage = [info objectForKey:@"storage"];
	NSDictionary *oldAttributes = [info objectForKey:@"oldAttributes"];

	NSRange range = NSMakeRange([[info objectForKey:@"rangeLocation"] intValue], [[info objectForKey:@"rangeLength"] intValue]);
	[storage beginEditing];
	[storage setAttributes:oldAttributes range:range];
	[storage endEditing];
}
@end
