//
//  ZSyntax.h
//  sEdit
//
//  Created by 増田 勇樹 on Thu Aug 05 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

extern NSString *ZSyntaxDescriptionFileName;	//@"syntax.plist"

/********************************************
* keys for dictionrary in syntax.plist file
********************************************/
extern NSString *ZSyntaxExtendsKey;	//@"extends"
extern NSString *ZSyntaxTopStateKey;	//@"topState"

/******************************
* Keys for Colors Dictionary 
******************************/
extern NSString *ColorsTextKey;			//@"text"
extern NSString *ColorsBackgroundKey;	//@"background"
extern NSString *ColorsCommentKey;		//@"comment"
extern NSString *ColorsPreprocessorKey;	//@"preprocessor"
extern NSString *ColorsStringKey;		//@"string"
extern NSString *ColorsParenthesisKey;	//@"parenthesis"
extern NSString *ColorsKeywordKey;		//@"keyword"
extern NSString *ColorsCharacterKey;	//@"character"
extern NSString *ColorsNumberKey;		//@"number"

extern NSString *ActionContextColorsKey, *ActionContextStringKey;

@class ZParseTree, ZUnicharCache;

@interface ZSyntax : NSObject
{
	ZParseTree *_coloringParseTree;
	ZUnicharCache *_cachedUnichars;
}
+ (ZSyntax *)syntaxWithDescription:(NSDictionary *)description;

- (id)initWithDescription:(NSDictionary *)desc;
- (void)applyToTextStorage:(NSTextStorage *)storage
		editedRange:(NSRange)editedRange
		changeInLength:(NSInteger)changeInLength
		colors:(NSDictionary *)colors;
		
- (void)applyColors:(NSDictionary *)colors textStorage:(NSTextStorage *)storage range:(NSRange)range;

- (void)showMatchIn:(NSTextStorage *)storage
		editedRange:(NSRange)editedRange
		changeInLength:(NSInteger)changeInLength
		selectedTextAttributes:(NSDictionary *)selected;
@end