//
//  ZTokenParser.m
//  ZEdit
//
//  Created by 増田 勇樹 on 08/10/09.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "ZTokenParser.h"

#import "ZKeywordParser.h"
#import "ZParseTree.h"

@implementation ZTokenParser
+ (ZTokenParser *)parserWithToken:(NSString *)token keywordParsers:(NSArray *)keywordParsers
{
	return [[[ZTokenParser alloc] initWithToken:token keywordParsers:keywordParsers] autorelease];
}

- (id)initWithToken:(NSString *)token keywordParsers:(NSArray *)keywordParsers
{
	self = [super init];
	if(self != nil)
	{
		[self setTrigger:token];
		_keywordScanner = [[ZScanner scanner] retain];
		for(ZKeywordParser *k in keywordParsers)
		{
			[_keywordScanner addRuleWithIdentifier:k regularExpression:[k trigger]];
		}
	}
	return self;
}

- (void)dealloc
{
	[_keywordScanner release];
	[super dealloc];
}

- (ZParseTree *)parse:(unichar *)characters length:(unsigned int)length triggerRange:(NSRange)triggerRange
{
	ZScannerMatch *match = [_keywordScanner matchInCharacters:characters length:length range:triggerRange];
	if(match != nil)
	{
		if(NSEqualRanges([match range], triggerRange))
		{
			ZKeywordParser *parser = [match identifier];
			ZParseTree *tree = [ZParseTree treeWithParser:parser];
			[tree setRange:triggerRange];
			[tree setTriggerLength:triggerRange.length];
			return tree;
		}
	}
	return nil;
}
@end
