//
//  ZUnicharCache.m
//  ZEdit
//
//  Created by 増田 勇樹 on 08/10/28.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "ZUnicharCache.h"


@implementation ZUnicharCache
+ (ZUnicharCache *)cache
{
	return [[[ZUnicharCache alloc] init] autorelease];
}

- (void)setString:(NSString *)string
{
	NSRange range = NSMakeRange(0, [self length]);
	[self edit:range changeInLength:range.length newString:string];
}

- (void)edit:(NSRange)range changeInLength:(int)changeInLength newString:(NSString *)newString
{
	unsigned int newLength = _length + changeInLength;
	if(_unichars == NULL)
	{
		_unichars = NSZoneMalloc(NSDefaultMallocZone(), newLength * sizeof(unichar));
	}
	else
	{
		if(changeInLength != 0)
		{
			_unichars = NSZoneRealloc(NSDefaultMallocZone(), _unichars, newLength * sizeof(unichar));
		}
	}
	
	NSRange updateRange = NSMakeRange(range.location, newLength - range.location);
	unichar *updateFrom = _unichars + range.location;
	[newString getCharacters:updateFrom range:updateRange];
	_length = newLength;
}

- (unichar *)unichars
{
	return _unichars;
}

- (unsigned int)length
{
	return _length;
}
@end
